import React, { ReactNode, useState, useEffect, Fragment } from 'react';
import Head from 'next/head';
import SideBar from '../../components/User/SideBar';
import TopBar from '../../components/User/TopBar';
import { Transition } from '@headlessui/react';

interface Props {
  children: ReactNode;
}

export default function UserLayout({ children }: Props) {
  const [showNav, setShowNav] = useState(false);
  const [isMobile, setIsMobile] = useState(false);

  const handleResize = () => {
    if (innerWidth < 768) {
      setShowNav(false);
      setIsMobile(true);
    } else {
      setShowNav(true);
      setIsMobile(false);
    }
  };

  useEffect(() => {
    if (typeof window != undefined) {
      addEventListener('resize', handleResize);
    }
    return () => {
      removeEventListener('resize', handleResize);
    };
  }, []);

  return (
    <>
      <Head>
        <title>Pokédex</title>
        <meta name="description" content="Generated by create next app" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />
        <link rel="icon" href="/icon.ico" />
      </Head>
      <TopBar showNav={showNav} setShowNav={setShowNav} />
      <Transition
        as={Fragment}
        show={showNav}
        enter="transform transition duration-[400ms]"
        enterFrom="-translate-x-full"
        enterTo="translate-x-0"
        leave="transform duration-[400ms] transition ease-in-out"
        leaveFrom="translate-x-0"
        leaveTo="-translate-x-full"
      >
        <SideBar showNav={showNav} />
      </Transition>
      <main
        className={`pt-16 transition-all bg-[#F6F6F6] duration-[400ms] h-full ${
          showNav && !isMobile ? 'pl-56' : ''
        }`}
      >
        <div className="px-4 md:px-16 ">{children}</div>
      </main>
    </>
  );
}
